package eu.jonahbauer.chat.bot.database.impl.types;

import lombok.RequiredArgsConstructor;
import org.jetbrains.annotations.NotNull;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Types;

@RequiredArgsConstructor
public class EnumTypeAdapter<E extends Enum<E>> implements TypeAdapter<E> {
    private final @NotNull Class<E> type;

    @Override
    public void prepare(@NotNull PreparedStatement stmt, int index, E value) throws SQLException {
        if (value == null) {
            stmt.setNull(index, Types.VARCHAR);
        } else {
            stmt.setString(index, value.name());
        }
    }

    @Override
    public E extract(@NotNull ResultSet result, int index) throws SQLException {
        return Enum.valueOf(type, result.getString(index));
    }
}
