package eu.jonahbauer.chat.bot.pizza.model.table;

import eu.jonahbauer.chat.bot.database.Entity;
import lombok.experimental.FieldNameConstants;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.time.Instant;
import java.util.Objects;

@FieldNameConstants
public record Order(
        long id,
        long eventId,
        long restaurantId,
        @NotNull String name,
        @NotNull Instant deadline,
        @Nullable Double payment
) implements Entity<Order>, Comparable<Order> {

    public Order {
        Objects.requireNonNull(deadline);
    }

    public @NotNull Order withPayment(@Nullable Double payment) {
        return new Order(id, eventId, restaurantId, name, deadline, payment);
    }

    @Override
    public int compareTo(@NotNull Order o) {
        return this.deadline.compareTo(o.deadline);
    }
}
