package eu.jonahbauer.chat.server.util;

import java.net.URLEncoder;
import java.nio.charset.StandardCharsets;

public enum UrlTemplateProcessor implements StringTemplate.Processor<String, RuntimeException> {
    URL;

    @Override
    public String process(StringTemplate template) throws RuntimeException {
        var out = new StringBuilder();

        var fragments = template.fragments();
        var values = template.values();

        for (int i = 0, length = values.size(); i < length; i++) {
            out.append(fragments.get(i));

            var value = values.get(i);
            if (value != null) {
                out.append(URLEncoder.encode(value.toString(), StandardCharsets.UTF_8));
            }
        }
        out.append(fragments.getLast());

        return out.toString();
    }
}
